<template>
  <div class="slide">
    <AnimatedImage :image="slide.imageUrl" :width="imgWidth" :height="imgHeight" />
    <div class="info">
      <LinedComponent>
        <h2 class="title">{{slide.title}}</h2>
        <p class="description">{{slide.description}}</p>
      </LinedComponent>
      <nuxt-link v-if="slide.action" :to="slide.action.link" class="action">
        <Button type="outlined" class="action__button">{{slide.action.title}}</Button>
      </nuxt-link>
    </div>
  </div>
</template>

<script>
import AnimatedImage from "@/components/base/AnimatedImage";
import LinedComponent from "@/components/base/LinedComponent";
import Button from "@/components/base/Button";

export default {
  name: "Slide",
  data() {
    return {
      width: 1200
    }
  },
  components: {
    AnimatedImage,
    LinedComponent,
    Button
  },
  props: {
    slide: {
      type: Object,
      required: true
    }
  },
  computed: {
    imgWidth() {
      if (this.width < 500) {
        return '88vw';
      } else if (this.width < 800) {
        return '89vw';
      } else if (this.width < 1200) {
        return '65vw';
      }
      return '750px';
    },
    imgHeight() {
      if (this.width < 500) {
        return '50vh';
      } else if (this.width < 1200) {
        return '67vh';
      }
      return '450px';
    }
  },
  methods: {
    sizeChangeHandler() {
      this.width = window.innerWidth;
    }
  },
  mounted() {
    this.width = window.innerWidth;
    window.addEventListener('resize', this.sizeChangeHandler);
  },
  beforeDestroy() {
    window.removeEventListener('resize', this.sizeChangeHandler);
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.slide
  display flex
  justify-content space-between
  align-items center
  @media only screen and (max-width 1200px)
    align-items flex-start
    flex-direction column

.info
  color $white
  margin-left $lg
  @media only screen and (max-width 1200px)
    margin-top $lg
    align-self flex-end
    display flex
    align-items center
    flex-direction row-reverse
    width 100%
  @media only screen and (max-width 700px)
    display block

.description
  font-size 2rem
  @media only screen and (max-width 500px)
    font-size 1.6rem

.title
  font-size 3.8rem
  font-weight 500
  margin-bottom $xxsm
  @media only screen and (max-width 500px)
    font-size 3.4rem

.action
  margin-top $md
  display flex
  justify-content flex-end
  padding-right $sm
  @media only screen and (max-width 1200px)
    margin-top 0
    margin-right auto
  @media only screen and (max-width 700px)
    margin-top $md
    padding-right 0
    margin-right 0
  &__button
    min-width 25rem
    @media only screen and (max-width 700px)
      width 100%
</style>